# $Id: fusion_logic.tac,v 1.4 2009/03/11 14:47:19 acau Exp $

# taccle Declarations
%token ID NEWLINE TRUE CLB CRB TLB TRB SAT VLD ENF INF
%token OR
%token FECHOP
%token CHOPSTAR
%token TEST
%token STEP
%token NEXT
%token NOT

%left OR
%left USTOR
%left UTROR
%left UFEOR
%left UCHOP
%left FECHOP
%left UCHOPSTAR
%left UTEST
%left USTEP
%left UNEXT
%left UNOT


# Grammar follows
%%
start: line NEWLINE start
 | line
;

line: cfl    { return $1 }
 | error     { puts " -- error "; return "error" }
 | # empty
;

cfl:  SAT fl                         { set _ [FLsat $2]  }
    | VLD fl                         { set _ [FLvld $2]  }
    | ENF fl                         { set _ [FLenf $2]  }
    | INF fl                         { set _ [FLinf $2]  }
;

fl:   ID                             { set _ $1              }
    | TRUE                           { set _ $1              }
    | TLB fe TRB fl %prec UCHOP      { set _ [FLchop $2 $4] }
    | fl OR fl                       { set _ [FLor $1 $3]   }
    | CLB fl CRB                     { set _ $2              }
    | NOT fl %prec UNOT              { set _ [FLnot $2]     }
;

fe:   CHOPSTAR fe %prec UCHOPSTAR  { set _ [FEchopstar $2] }
    | STEP tr  %prec USTEP         { set _ [FEstep $2 ]    }
    | TEST st  %prec UTEST         { set _ [FEtest $2]     }
    | fe OR fe %prec UFEOR         { set _ [FEor $1 $3]    }
    | fe FECHOP fe                 { set _ [FEchop $1 $3 ] }
    | CLB fe CRB                   { set _ $2               } 
;

tr:   ID                      { set _ $1             }
    | TRUE                    { set _ $1             }  
    | tr OR tr  %prec UTROR   { set _ [TRor $1 $3] }
    | CLB tr CRB              { set _ $2            }
    | NEXT st %prec UNEXT     { set _ [TRnext $2]  }   
    | NOT tr  %prec UNOT      { set _ [TRnot $2]   }
;


st:   ID                       { set _ $1             }
     | TRUE                    { set _ $1             }
     | st OR st %prec USTOR    { set _ [STor $1 $3]  }
     | CLB st CRB              { set _ $2            }
     | NOT st %prec UNOT       { set _ [STnot $2]    }
;

%%

source fusion_logic_derived.tcl
source fusion_logic_commands.tcl
source scanner_fusion_logic.tcl


