# flcheck --
#
# This file implements package flcheck, a fusion logic modelchecker 
# using the CUDD BDD package
#
# Copyright (C) 2009, 2010  Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

# FL derived
#####################################

proc l_and {alist} {
    set x "true"
    foreach e $alist {
        set x "[and $x $e]"
    }
    return $x
}


proc tl_and {alist} {
    set x "true"
    foreach e $alist {
        set x "{tand $x $e}"
    }
    return $x
}


proc len { n } {
    return "<[len_e $n]>[empty]"
}

proc len_e { n } {
    if {$n < 0 } { 
        return "test{[false]}"
    } else {
      if {$n == 0 } {
          return "test{true}"
      } else {
          return "step{true};[len_e [incr n -1]]"
      }
    }
}

proc and {a b} {
    return "not{not{$a} or not{$b}}"
}

proc implies {a b} {
    return "not{$a} or {$b}"
}

proc equiv {a b} {
    set x "not{$a}"
    set y "not{$b}"
    return "[and $a $b] or [and $x  $y]"
}

proc next_fl {a} {
    return "<[skip_e]>{$a}"
}

proc sometimes { a } { 
    return "<[finite_e]>{$a}"
}

proc sometimes_e { a } {
    return "[finite_e];{$a}"
}

proc always { a } {
    return "not<[finite_e]>{not{$a}}"
}

proc skip_e {} {
    return "step{true}"
}

proc empty_e {} {
    return "test{true}"
}

proc finite_e {} {
    return "chopstar{step{true}}"
}

proc false {} {
    return "{not true}"
}

proc more {} {    
    return "<[skip_e]>{true}"
}

proc empty {} {    
    return "not{[more]}"
}

proc skip {} {    
    return "<[skip_e]>{[empty]}"
}

proc finite {} {
    return "<[finite_e]>{[empty]}"
}

proc fin { a } {
    return "[always [implies [empty] $a]]"
}

#proc fin { a } {
#    return "<[finite_e]; test{$a}> { [empty] }"
#}



