# flcheck --
#
# This file implements package flcheck, a fusion logic modelchecker 
# using the CUDD BDD package
#
# Copyright (C) 2009, 2010  Antonio Cau

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.

#############################################################################
# 
# policy library
#
#############################################################################

proc p_rule_1  { a b } {
    return "not{<{$a}>{not{ $b }}}"
}

proc p_rule_1_true  { b } {
    return "not{<[finite_e]>{not{ $b }}}"
}

proc strong_p_rule_1_true  { b } {
#    puts " true  strong_p_rule_1_true $b"
    return "[always $b]"
}

proc p_rule_2 { a b } {
    return "not{< $a > {not{ $b }}}" 
}

proc p_rule_s_1 { a b } {
    return "not{<[finite_e];test{$a};[finite_e]>{not{ $b }}}"  
} 



proc p_rule_s_2 { a b } {
    return "not{<test{$a};[finite_e]>{not{ $b }}}"   
}


proc p_rule_s_1_k { k a b } {
    return "not{<[finite_e];test{$a};[len_e $k]>{not{ $b }}}"  
} 

proc strong_p_rule_s_1_0 { a b } {
#remember to put always at outer level
    insert "RULE: $a   strong_p_rule_0   $b"
    return "[equiv $a $b]"  
}

proc p_rule_s_2_k { k a b } {
    return "not {< test { $a }; [len_e $k]> { not { $b } } }"   
}

#proc sprule3 { a b } {
#    return "<[finite_e]> { [and [empty] [equiv $a   $b]] }"  
#}

